{-# LANGUAGE TemplateHaskell #-}
module Skynet.Protocol.Happstack where

import Skynet.Protocol.Base
import Happstack.State
import System.Posix.Types
import Foreign.C.Types
import Data.Int
import Data.Word
import Control.Applicative
import Data.Binary(Binary(..))

-- Happstack serializers
deriveSerializeFor [''Address, ''LeaseType, ''LeaseMode, ''Coherency, ''Lease, ''URIType, ''URI]


-- The below instances cannot be derived, due to not exporting
-- internals. Converting to integers and back works, however.
instance Version CTime
instance Version CMode

instance Binary CTime where
  get = (fromIntegral :: Int64 -> CTime) <$> get
  put = put . (truncate . toRational :: CTime -> Int64)

instance Binary CMode where
  get = (fromIntegral :: Word32 -> CMode) <$> get
  put = put . (fromIntegral :: CMode -> Word32)

instance Serialize CTime where
  getCopy = contain get
  putCopy = contain . put

instance Serialize CMode where
  getCopy = contain get
  putCopy = contain . put
