import Network.Hermes
import qualified Data.ByteString as B
import System.Environment
import Control.Monad
import Control.Concurrent
import Control.Applicative
import System.Log.Logger

main = withHermes $ do
  num <- read . head <$> getArgs
  ctx <- restoreContext =<< B.readFile (show num ++ ".ctx")
  runTest num ctx

address n = IPv4 "localhost" (8000+n)

runTest :: Int -> Context -> IO ()
runTest num ctx = do
  putStrLn $ "I am " ++ show (uuid ctx)
  updateGlobalLogger "hermes.gossip" (setLevel DEBUG)
  updateGlobalLogger "hermes.address" (setLevel DEBUG)
  setPeriod ctx 5
  startListener ctx (address num) Nothing
  unless (num == 0) (connect ctx (address 0) >> return ())
  threadDelay 90000000
