-- | A safe interface to SHA that still lets you digest incrementally
module Codec.Digest.SHA.Reader(
  SHAT, showBSasHex
) where

import Codec.Digest.SHA.IO
import qualified Data.ByteString as B

import Control.Monad.Trans.UnsafeIO
import Control.Applicative

data SHAT m a = SHAT ShaCtx (m a)

runSHAT :: SHAT m a -> m (B.ByteString,a)
runSHAT (SHAT ctx m) = (,) <$> liftUnsafeIO (unsafeFinalizeCtx ctx) <*> m
